var maxUpScaleFactor = 1.25;
var currentScreenId = 12;
var port = null;
var nativeErrorMsg = false;
var array = new Array();
var ctx;
var openConn = false;
var canvasObj;
var points = [];
var tempPoints = [];
var sizeX = 0, sizeY = 0;
var epadScale;
var signWidth;
var errMsg = "";
var signHeight;
var scale = 0;
var xScale = 0;
var yScale = 0;
var minX = 99999, minY = 99999, maxX = 0, maxY = 0;
//ePad Vision physical sizes
var dev_physicalX = 3.742;
var dev_physicalY = 2.12;
var dpi = 96; // Need to replace this with value read from JS APIS::: Screen Resolution
var g_fFirstTouch = false;
var g_lastX = 0;
var orgWidth = 400;
var orgHeight = 200;
var g_lastY = 0;
var execPinPad = false;
var isSigned = false;
var sendResponse1;
var sendResponse;
var acceptButtonClicked=false;

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// XML for creation of signature capture screen
var xml = "<WidgetLayout><Widget ID=\"2\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"80\" Y=\"220\" Effect=\"ThreeD\" Text=\"Accept\"/><Widget ID=\"3\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"200\" Y=\"220\" Effect=\"ThreeD\" Text=\"Clear\"/><Widget ID=\"4\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"320\" Y=\"220\" Effect=\"ThreeD\" Text=\"Cancel\"/></WidgetLayout>";
var pinPadxml1 = "<PinPad><Widget ID=\"NUM_0\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"20\" Y=\"200\" Effect=\"ThreeD\"/><Widget ID=\"NUM_1\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"20\" Y=\"20\" Effect=\"ThreeD\"/><Widget ID=\"NUM_2\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"80\" Y=\"20\" Effect=\"ThreeD\"/><Widget ID=\"NUM_3\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"140\" Y=\"20\" Effect=\"ThreeD\"/><Widget ID=\"NUM_4\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"20\" Y=\"80\" Effect=\"ThreeD\" /><Widget ID=\"NUM_5\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"80\" Y=\"80\" Effect=\"ThreeD\" /><Widget ID=\"NUM_6\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"140\" Y=\"80\" Effect=\"ThreeD\" /><Widget ID=\"NUM_7\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"20\" Y=\"140\" Effect=\"ThreeD\" /><Widget ID=\"NUM_8\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"80\" Y=\"140\" Effect=\"ThreeD\" /><Widget ID=\"NUM_9\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"140\" Y=\"140\" Effect=\"ThreeD\" /><Widget ID=\"FUN_BACKSPACE\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"120\" Height=\"60\" X=\"80\" Y=\"200\" Effect=\"ThreeD\" Text=\"Backspace\"/><Widget ID=\"CAPTION\" FontName=\"SAN_R_13\" BGColor=\"EDF0F5\" FGColor=\"000000\" Width=\"240\" Height=\"20\" X=\"220\" Y=\"26\" Effect=\"None\" Text=\"Use the pad on the left to enter your pin.\" /><Widget ID=\"CONTENT\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"240\" Height=\"30\" X=\"220\" Y=\"40\" Effect=\"ThreeD\" /><Widget ID=\"FUN_SEC\" FontName=\"SAN_R_20\" BGColor=\"EDF0F5\" FGColor=\"FF0000\" Width=\"240\" Height=\"20\" X=\"220\" Y=\"70\" Effect=\"ThreeD\" Text=\"Hide the text\" /><Widget ID=\"FUN_OK\" FontName=\"COM_B_24\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"100\" Height=\"60\" X=\"240\" Y=\"100\" Effect=\"ThreeD\"Text=\"OK\"/><WidgetID=\"FUN_CANCEL\"FontName=\"COM_B_24\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"100\" Height=\"60\" X=\"340\" Y=\"100\" Effect=\"ThreeD\" Text=\"Cancel\"/></PinPad>";
var pinPadxml = "<PinPad><Widget ID=\"NUM_1\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"275\" Y=\"2\" Effect=\"ThreeD\" /><Widget ID=\"NUM_2\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"340\" Y=\"2\" Effect=\"ThreeD\" /><Widget ID=\"NUM_3\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"405\" Y=\"2\" Effect=\"ThreeD\" /><Widget ID=\"NUM_4\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"275\" Y=\"74\" Effect=\"ThreeD\" /><Widget ID=\"NUM_5\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"340\" Y=\"74\" Effect=\"ThreeD\" /><Widget ID=\"NUM_6\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"405\" Y=\"74\" Effect=\"ThreeD\" /><Widget ID=\"NUM_7\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"275\" Y=\"146\" Effect=\"ThreeD\" /><Widget ID=\"NUM_8\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"340\" Y=\"146\" Effect=\"ThreeD\" /><Widget ID=\"NUM_9\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"405\" Y=\"146\" Effect=\"ThreeD\" /><Widget ID=\"NUM_0\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"275\" Y=\"218\" Effect=\"ThreeD\" /><Widget ID=\"FUN_BACKSPACE\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"125\" Height=\"60\" X=\"340\" Y=\"218\" Effect=\"ThreeD\" Text=\"Backspace\" /><Widget ID=\"CAPTION\" FontName=\"SAN_R_16\" BGColor=\"000000\" FGColor=\"FFFF00\" Width=\"240\" Height=\"40\" X=\"10\" Y=\"5\" Effect=\"None\" Text=\"Use the pad on the right to enter your pin.\" /><Widget ID=\"CONTENT\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"220\" Height=\"30\" X=\"10\" Y=\"60\" Effect=\"ThreeD\" /><Widget ID=\"FUN_SEC\" FontName=\"SAN_R_20\" BGColor=\"9C9C9C\" FGColor=\"FF0000\" Width=\"220\" Height=\"20\" X=\"10\" Y=\"100\" Effect=\"ThreeD\" Text=\"Hide the text\" /><Widget ID=\"FUN_OK\" FontName=\"COM_B_24\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"100\" Height=\"60\" X=\"10\" Y=\"150\" Effect=\"ThreeD\" Text=\"OK\"/><Widget ID=\"FUN_CANCEL\" FontName=\"COM_B_24\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"100\" Height=\"60\" X=\"120\" Y=\"150\" Effect=\"ThreeD\" Text=\"Cancel\"/></PinPad>";
var confirmXml = "<WidgetLayout><Widget ID=\"11\" Type=\"TEXT\" FontName=\"SAN_B_24\" BGColor=\"0000FF\" FGColor=\"ffd700\" Width=\"450\" Height=\"100\" X=\"10\" Y=\"10\" Effect=\"NONE\" Text=\"In this transaction, you have the option to capture your signature electronically or enter your pin or opt-out. Please make your selection below.\" /><Widget ID=\"12\" Type=\"RADIOBUTTON\" FontName=\"SAN_B_16\" BGColor=\"0000FF\" FGColor=\"ffd700\" Width=\"320\" Height=\"34\" X=\"50\" Y=\"110\" Effect=\"NONE\" Text=\"Continue with signing process electronically\" GrpID=\"1\" /><Widget ID=\"13\" Type=\"RADIOBUTTON\" FontName=\"SAN_B_16\" BGColor=\"0000FF\" FGColor=\"ffd700\" Width=\"170\" Height=\"34\" X=\"50\" Y=\"140\" Effect=\"NONE\" Text=\"Entering pin number\" GrpID=\"1\" /><Widget ID=\"14\" Type=\"RADIOBUTTON\" FontName=\"SAN_B_16\" BGColor=\"0000FF\" FGColor=\"ffd700\" Width=\"150\" Height=\"34\" X=\"50\" Y=\"170\" Effect=\"NONE\" Text=\"Opt-out\" GrpID=\"1\" /><Widget ID=\"15\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FF00\" FGColor=\"ffd700\" Width=\"50\" Height=\"50\" X=\"200\" Y=\"220\" Effect=\"ThreeD\" Text=\"OK\" GrpID =\"2\" /></WidgetLayout>";

/*
// Adding DOM events to controls 
document.addEventListener('DOMContentLoaded', function() {    
console.log("into Add event listener");       
	   document.getElementById('connect').addEventListener(
      'click', connect);
        document.getElementById('connect').addEventListener(
      'click', openConnection);    
});
*/
window.onload = connect;
window.onunload = disconnect;

// Disconnect Event
function disconnect() {
console.log("Into disconnect");
    closeConnection();
}
// Connecting to Native Host (connect Event)
function connect() {
    console.log("Into connect");
    port = null;
    ClearALL();
    openConn = false;
    var hostName = "com.topaz.epadvision.win";
    points.length = 0;
    currentScreenId = 12;
    tempPoints.length = 0;
    if (canvasObj != null) {
        canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
    }
    console.log("Before connectNative");
    port = chrome.runtime.connectNative(hostName);
    console.log("After connectNative");
    if (port != null) {
        console.log("Connected");
    }
    console.log("After Connection succeed");
    port.onMessage.addListener(onNativeMessage);
    port.onDisconnect.addListener(onDisconnected);
    openConnection();
}

// Receiving response from Native Host (onNativeMessage Event)
function onNativeMessage(message) {
    console.log("onNativeMessage  : " + message);
    var resMsg = "";
    var message1 = message;
    var obj = JSON.parse(JSON.stringify(message1));
    if (obj.message == "Invalid command") {
        SetTextOnCanvas(obj.message, true);
        closeConnection();
        document.getElementById('lblError').innerText = obj.message;
        errMsg = obj.message;
        
    }
    if (obj.command == 1 || obj.command == 2 || obj.command == 3) {
        if (obj.message == "") {
            openConn = true;
        }
        if (obj.message != null && obj.message != "" && obj.message != undefined) {
            port = null;
            document.getElementById('lblError').innerText = obj.message;
            errMsg = obj.message;
            console.log("Error Message :" + obj.message);
            SetTextOnCanvas(obj.message, false);
        }
    }
    else if (obj.command == 4) {
        if (obj.status) {
            if (obj.message == undefined || obj.message == "") {
                document.getElementById('lblError').innerText = "";
                var err = "Invalid pin specified. Pin should not be null or empty."
                errMsg = err;
                SetTextOnCanvas(err, false);
                closeConnection();
                document.getElementById('lblError').innerText = err;
                return;
            }
            resMsg = "The entered PIN is : " + obj.message;
            SetTextOnCanvas(resMsg, false);
        }
        else {
            isSigned = true;
            resMsg = obj.message;
            canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
            SetTextOnCanvas(obj.message, true);
        }
        closeConnection();
        document.getElementById('lblError').innerText = resMsg;
        errMsg = resMsg;
    }
    else if (obj.command == 102) {
        if (obj.widgetID == 13 || obj.widgetID == 14 || obj.widgetID == 12) {
            currentScreenId = obj.widgetID;
        }
        if (obj.widgetID == 15) {
            if (currentScreenId == 12) {
                createScreen();
            }
            if (currentScreenId == 13) {
                CreatePINPad();
                execPinPad = true;
            }
            if (currentScreenId == 14) {
                ClearALL();
				document.getElementById('lblError').innerText = "User opt out.";
				errMsg = resMsg;
            }
        }
        if (obj.widgetID == 2) {
			acceptButtonClicked=true;
            isSigned = true;
            execPinPad = false;
            closeConnection();
        }
        else if (obj.widgetID == 3) {
            message = { "command": 5, "inking": false, "inkRegionx": 0, "inkRegiony": 0, "inkRegionWidth": 0, "inkRegionHeight": 0, "widgetLayout": "" };
            port.postMessage(message);
            points.length = 0;
            tempPoints.length = 0;
            canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
            canvasObj.getContext('2d').beginPath();
			acceptButtonClicked=false;
        }
        else if (obj.widgetID == 4) {
			acceptButtonClicked=false;
            ClearALL();
            //SetTextOnCanvas("User cancelled signing.", true);
            document.getElementById('lblError').innerText = "User cancelled signing.";
            errMsg = resMsg;
        }
    }
    if (obj.xAxis != undefined && obj.yAxis != undefined) {
        points.push({ x: (obj.xAxis), y: (obj.yAxis), pressure: (obj.pressure) });

        if (points.length > 0) {
            var lCurX = 0.0;
            var lCurY = 0.0;
            //calculate the X and Y with respect to the currently set drawing object
            lCurX = xScale * obj.xAxis;
            lCurY = yScale * obj.yAxis;
            //check if pen down or pen up
            if (obj.pressure != 0) {
                //check if it is the first touch in the stroke
                if (g_fFirstTouch) {
                    //draw the line
                    ctx.moveTo(lCurX, lCurY)
                    g_fFirstTouch = false;
                }
                else {
                    ctx.lineTo(lCurX, lCurY)
                    ctx.stroke();
                }
            }
            else {
                //set the first touch 
                g_fFirstTouch = true; ;
            }
        }
    }
}

// Disconnect (onDisconnected Event)
function onDisconnected() {
    
    console.log("chrome.runtime.lastError.message : " + chrome.runtime.lastError.message);
    // Check if host is exited normally or not. If not show the message
    // Reason for non normal exit is non availability of drivers etc.
    if (chrome.runtime.lastError.message != "Native host has exited.") {
        document.getElementById('lblError').innerText = chrome.runtime.lastError.message;
        errMsg = chrome.runtime.lastError.message; 
    }
    if (document.getElementById('lblError').innerText != "Please wait....") {
        
            SetSignatureImage(null, false);

        }
    console.log("Disconnected");

    port = null;
}

// Open a Connection (openConnection Method)
function openConnection() {
    console.log("Open connection - Port : " + port);
    canvasObj = document.getElementById('cCanvas');
    if (canvasObj != null) {
        canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
        canvasObj.getContext('2d').beginPath();
    }
    points.length = 0;
    document.getElementById('lblError').innerText = "Please wait....";

    message = { "command": 1, "inking": false, "inkRegionx": 0, "inkRegiony": 0, "inkRegionWidth": 0, "inkRegionHeight": 0, "widgetLayout": confirmXml };
    port.postMessage(message);
}

// Creating a screen on device (createScreen Method)
function createScreen() {
    message = { "command": 3, "inking": true, "inkRegionx": 0, "inkRegiony": 0, "inkRegionWidth": 480, "inkRegionHeight": 200, "widgetLayout": xml };
    port.postMessage(message);
    initDrawParams();
}

// Creating a pin pad screen (CreatePINPad Method)
function CreatePINPad() {
    message = { "command": 4, "inking": false, "inkRegionx": 0, "inkRegiony": 0, "inkRegionWidth": 0, "inkRegionHeight": 0, "widgetLayout": pinPadxml };
    port.postMessage(message);
    execPinPad = true;
}

// Closing a connection (closeConnection method)
function closeConnection() {
    document.getElementById('lblError').innerText = "";
    
    message = { "command": 2, "inking": false, "inkRegionx": 0, "inkRegiony": 0, "inkRegionWidth": 0, "inkRegionHeight": 0, "widgetLayout": "" };
    port.postMessage(message);
    var imgData;
    if (canvasObj != null)
        imgData = canvasObj.toDataURL();
    if (isSigned) {
        if (points.length > 0)
            scaleAndDrawSignature();
    }
   var imgData = canvasObj.toDataURL();
   // if (imgData != "" && imgData != null) {
       //alert("one"+acceptButtonClicked);
	if(acceptButtonClicked) 
	{
        	if (tempPoints != null) 
			{
				if (tempPoints.length > 0) {
					SetSignatureImage(imgData,true);
					execPinPad = false;
				}
				else {
					if (!execPinPad) {
							SetTextOnCanvas("The signature does not have enough points to be valid.", false);
							document.getElementById('lblError').innerText = "The signature does not have enough points to  be valid.";
							SetSignatureImage(null, true);
							errMsg = document.getElementById('lblError').innerText;
					}
				}
        	}
        	else
			{
				if (!execPinPad) 
				{
					SetTextOnCanvas("The signature does not have enough points to be valid.", false);
					document.getElementById('lblError').innerText = "The signature does not have enough points to be valid.";
					errMsg = document.getElementById('lblError').innerText;
				}
				SetSignatureImage(null,true);
			}
    }
	else
	{
		SetSignatureImage(null,true);
	}
    
    
    points.length = 0;
    currentScreenId = 12;           
    acceptButtonClicked	=false;
 }

function SetSignatureImage(imageData, allow) {    
     console.log(errMsg);
    console.log(document.getElementById('lblError').innerText);
    chrome.runtime.getBackgroundPage(function(bgWindow) {
    bgWindow.setImage(imageData, document.getElementById('lblError').innerText);
        window.close();
    });
}
// Initializes required parameters for drawing live signature rendering on Canvas.(initDrawParams Method)
function initDrawParams() {
    g_fFirstTouch = true;
    document.getElementById('lblError').innerText = "";    
    canvasObj = document.getElementById('cCanvas');
    ctx = canvasObj.getContext('2d');
    ctx.lineWidth = 2;
    points.length = 0;
    ctx.strokeStyle = "blue";
    ctx.lineJoin = ctx.lineCap = 'round';
    var deviceWidthinPX = 1024;
    var deviceHeightinPx = 1024;
    xScale = parseInt(canvasObj.width) / deviceWidthinPX;
    yScale = parseInt(canvasObj.height) / deviceHeightinPx;
    epadScale = xScale;
    if (xScale > yScale) epadScale = yScale;
    ctx.beginPath();
}

// Redrawing the signature after scaling.(scaleAndDrawSignature Method)
function scaleAndDrawSignature() {
    canvasObj = document.getElementById('cCanvas');
    ctx = canvasObj.getContext('2d');

    //ePad Vision physical sizes
    var dev_physicalX = 3.742;
    var dev_physicalY = 2.12;
    var dpi = 96; // Need to replace this with value read from JS APIS::: Screen Resolution
    //compute the width and height of the component in inches.
    var xLengthInInches = 0.0, yLengthInInches = 0.0;
    var xLengthPx = 0, yLengthPx = 0;
    xLengthPx = parseInt(canvasObj.width);
    yLengthPx = parseInt(canvasObj.height);
    xLengthInInches = xLengthPx / 96; // this dpi
    yLengthInInches = yLengthPx / 96;
    // Compute minimum x, y of the device reported points.
    minX = points[0].x;
    minY = points[0].y;

    if (maxX == 0) {
        maxX = points[0].x;
    }
    if (maxY == 0) {
        maxY = points[0].y;
    }
    for (var i = 1; i < points.length; i++) {
        if (maxX < points[i].x) {
            maxX = points[i].x;
        }
        if (minX > (points[i].x) && (points[i].x) != 0) {
            minX = (points[i].x);
        }
    }
    for (var i = 0; i < points.length; i++) {
        if (maxY <= points[i].y) {
            maxY = points[i].y;
        }
        if (minY > points[i].y && points[i].y != 0) {
            minY = points[i].y;
        }
    }
    // Translate the points to origin
    for (var i = 0; i < points.length; i++) {
        var tempX = points[i].x - minX;
        var tempY = points[i].y - minY;
        tempPoints.push({ x: (tempX), y: (tempY), pressure: (points[i].pressure) });
    }
    // compute the width and height of the signature
    sizeX = maxX - minX + 1;
    sizeY = maxY - minY + 1;
    var DeviceX1 = 0.0, DeviceY1 = 0.0;
    DeviceX1 = sizeX * dev_physicalX / maxX;
    DeviceY1 = sizeY * dev_physicalY / maxY;
    var xScale = 0.0, yScale = 0.0;
    xScale = xLengthInInches / DeviceX1;
    yScale = yLengthInInches / DeviceY1;
    scale = xScale;
    if (xScale > yScale) {
        scale = yScale;
    }
    if (scale > 1.0) {
        if (maxUpScaleFactor > scale) {
            scale = scale;
        } else {
            scale = maxUpScaleFactor;
        }
    }
    scale = 0.95 * scale; //this is to avoid cutting of edges when thickness is set to a higher value    
    var xOffset = 0.0, yOffset = 0.0;
    xOffset = ((xLengthInInches - DeviceX1 * scale) / 2.0) * dpi;
    yOffset = ((yLengthInInches - DeviceY1 * scale) / 2.0) * dpi;
    var g_fFirstTouch = true;
    canvasObj = document.getElementById('cCanvas');
    ctx = canvasObj.getContext('2d');
    ctx.lineWidth = 4;
    points.length = 0;
    ctx.strokeStyle = "blue";
    ctx.lineJoin = ctx.lineCap = 'round';
    canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
    ctx.beginPath();
    for (var i = 0; i < tempPoints.length; i++) {
        var xone = (tempPoints[i].x * DeviceX1 * scale / sizeX) * dpi;
        var yone = (tempPoints[i].y * DeviceY1 * scale / sizeY) * dpi;
        xone = xone + xOffset;
        yone = yone + yOffset;
        if (tempPoints[i].pressure != 0) {
            //check if it is the first touch in the stroke
            if (g_fFirstTouch) {
                //draw the line
                ctx.moveTo(xone, yone)
                g_fFirstTouch = false;
            }
            else {
                ctx.lineTo(xone, yone)
                ctx.stroke();
            }
        }
        else {
            //set the first touch 
            g_fFirstTouch = true; ;
        }
    }
}

// Set the image data to the image tag (SetSignatureImage method)

// Resets the controls (ClearALL Method)
function ClearALL() {    

    if (canvasObj != null) {
        canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
    }
    document.getElementById('lblError').innerText = "";
    execPinPad = true;
    points.length = 0;
    tempPoints.length = 0;
    sizeX = 0;
    sizeY = 0;
    scale = 0.0;
    minX = 99999;
    minY = 99999;
    maxX = 0;
    maxY = 0;
    if (port != null) {
        closeConnection();
    }    
    isSigned = false;
    port = null;
}

// Set the text on canvas (SetTextOnCanvas Method)
function SetTextOnCanvas(msg, allow) {
    canvasObj = document.getElementById('cCanvas');
    ctx = canvasObj.getContext("2d");
    ctx.font = '20pt Calibri';
    ctx.fillStyle = 'blue';
    if (allow) {
        ctx.fillText(msg, 10, 90);
    }
    else {
        var maxWidth = 400;
        var x = (canvasObj.width - maxWidth) / 2;
        var y = 50;
        var lineHeight = 25;
        var minLength = 10;
        wrapText(ctx, msg, x, y, maxWidth, lineHeight);
    }
    if (canvasObj != null)
       SetSignatureImage(canvasObj.toDataURL(),null);
}

// Wrap the text on Canvas (wrapText method)
function wrapText(context, text, x, y, maxWidth, lineHeight) {
    var words = text.split(' ');
    var line = '';
    for (var n = 0; n < words.length; n++) {
        var testLine = line + words[n] + ' ' + ' ';
        var metrics = context.measureText(testLine);
        var testWidth = metrics.width;
        if (testWidth > maxWidth && n > 0) {
            context.fillText(line, x, y);
            line = words[n] + ' ';
            y += lineHeight;
        }
        else {
            line = testLine;
        }
    }
    context.fillText(line, x, y);
}
