Components.utils.import("resource://gre/modules/ctypes.jsm");
Components.utils.import("resource://gre/modules/Services.jsm");
Components.utils.import("resource://gre/modules/Timer.jsm");
//Components.classes["@mozilla.org/net/osfileconstantsservice;1"].getService(Components.interfaces.nsIOSFileConstantsService).init();
const consoleJSM =Components.utils.import("resource://gre/modules/devtools/Console.jsm",{});
let console = consoleJSM.console;
var profileDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile).path ;
var mylibPath_win = profileDir + "/extensions/support@topazsystems.com/FireFoxExtension.dll";
var mylibPath_linux = profileDir + "/extensions/support@topazsystems.com/libFireFoxExtension.so";
var mylib
var retval;
var cmdOpenConn;
var cmdOpenConnObj;
var commandReturnVal;
var send=null;
var currentScreenId = 12;
var currentEventCode=0;
// Declarations for canvas drawing
var maxUpScaleFactor = 1.25;
var array = new Array();
var ctx;
var openConn = false;
//var canvasObj = document.getElementById('cCanvas');
var canvasObj;
var renderingOption;
var points = [];
var tempPoints = [];
var sizeX = 0, sizeY = 0;
var epadScale;
var signWidth;
var signHeight;
var scale = 0;
var xScale = 0;
var yScale = 0;
var minX = 99999, minY = 99999, maxX = 0, maxY = 0;
//ePad Vision physical sizes
var dev_physicalX = 3.742;
var dev_physicalY = 2.12;
var dpi = 96; // Need to replace this with value read from JS APIS::: Screen Resolution
var g_fFirstTouch = false;
var g_lastX = 0;
var orgWidth = 400;
var orgHeight = 200;
var g_lastY = 0;
var execPinPad = false;
var isSigned = false;
var SigData = "";
var gTimer;
var bFound;
//End of declarations for canvas drawing

//Function variables declerations
var signatureFunc;
var widgetFunc;
var isConnOpen=false;
var isCancelled=false;
var timeoutID;
var prevClick;
// XML for creation of signature capture screen
 var xml = "<WidgetLayout><Widget ID=\"2\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"80\" Y=\"220\" Effect=\"ThreeD\" Text=\"Accept\"/><Widget ID=\"3\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"200\" Y=\"220\" Effect=\"ThreeD\" Text=\"Clear\"/><Widget ID=\"4\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"320\" Y=\"220\" Effect=\"ThreeD\" Text=\"Cancel\"/></WidgetLayout>";
 
var confirmXml = "<WidgetLayout><Widget ID=\"11\" Type=\"TEXT\" FontName=\"SAN_B_24\" BGColor=\"0000FF\" FGColor=\"ffd700\" Width=\"450\" Height=\"100\" X=\"10\" Y=\"10\" Effect=\"NONE\" Text=\"In this transaction, you have the option to capture your signature electronically or enter your pin or opt-out. Please make your selection below.\" /><Widget ID=\"12\" Type=\"RADIOBUTTON\" FontName=\"SAN_B_16\" BGColor=\"0000FF\" FGColor=\"ffd700\" Width=\"320\" Height=\"34\" X=\"50\" Y=\"110\" Effect=\"NONE\" Text=\"Continue with signing process electronically\" GrpID=\"1\" /><Widget ID=\"13\" Type=\"RADIOBUTTON\" FontName=\"SAN_B_16\" BGColor=\"0000FF\" FGColor=\"ffd700\" Width=\"170\" Height=\"34\" X=\"50\" Y=\"140\" Effect=\"NONE\" Text=\"Entering pin number\" GrpID=\"1\" /><Widget ID=\"14\" Type=\"RADIOBUTTON\" FontName=\"SAN_B_16\" BGColor=\"0000FF\" FGColor=\"ffd700\" Width=\"150\" Height=\"34\" X=\"50\" Y=\"170\" Effect=\"NONE\" Text=\"Opt-out\" GrpID=\"1\" /><Widget ID=\"15\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FF00\" FGColor=\"000000\" Width=\"50\" Height=\"50\" X=\"200\" Y=\"220\" Effect=\"ThreeD\" Text=\"OK\" GrpID =\"2\" /></WidgetLayout>";

 
 var createScreenXml = "<WidgetLayout><Widget ID=\"2\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"80\" Y=\"220\" Effect=\"ThreeD\" Text=\"Accept\"/><Widget ID=\"3\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"200\" Y=\"220\" Effect=\"ThreeD\" Text=\"Clear\"/><Widget ID=\"4\" Type=\"BUTTON\" FontName=\"SAN_B_16\" BGColor=\"00FFFF\" FGColor=\"000000\" Width=\"80\" Height=\"34\" X=\"320\" Y=\"220\" Effect=\"ThreeD\" Text=\"Cancel\"/></WidgetLayout>";

var pinPadxml = "<PinPad><Widget ID=\"NUM_1\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"275\" Y=\"2\" Effect=\"ThreeD\" /><Widget ID=\"NUM_2\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"340\" Y=\"2\" Effect=\"ThreeD\" /><Widget ID=\"NUM_3\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"405\" Y=\"2\" Effect=\"ThreeD\" /><Widget ID=\"NUM_4\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"275\" Y=\"74\" Effect=\"ThreeD\" /><Widget ID=\"NUM_5\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"340\" Y=\"74\" Effect=\"ThreeD\" /><Widget ID=\"NUM_6\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"405\" Y=\"74\" Effect=\"ThreeD\" /><Widget ID=\"NUM_7\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"275\" Y=\"146\" Effect=\"ThreeD\" /><Widget ID=\"NUM_8\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"340\" Y=\"146\" Effect=\"ThreeD\" /><Widget ID=\"NUM_9\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"70\" X=\"405\" Y=\"146\" Effect=\"ThreeD\" /><Widget ID=\"NUM_0\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"60\" Height=\"60\" X=\"275\" Y=\"218\" Effect=\"ThreeD\" /><Widget ID=\"FUN_BACKSPACE\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"125\" Height=\"60\" X=\"340\" Y=\"218\" Effect=\"ThreeD\" Text=\"Backspace\" /><Widget ID=\"CAPTION\" FontName=\"SAN_R_16\" BGColor=\"000000\" FGColor=\"FFFF00\" Width=\"240\" Height=\"40\" X=\"10\" Y=\"5\" Effect=\"None\" Text=\"Use the pad on the right to enter your pin.\" /><Widget ID=\"CONTENT\" FontName=\"SAN_B_20\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"220\" Height=\"30\" X=\"10\" Y=\"60\" Effect=\"ThreeD\" /><Widget ID=\"FUN_SEC\" FontName=\"SAN_R_20\" BGColor=\"9C9C9C\" FGColor=\"FF0000\" Width=\"220\" Height=\"20\" X=\"10\" Y=\"100\" Effect=\"ThreeD\" Text=\"Hide the text\" /><Widget ID=\"FUN_OK\" FontName=\"COM_B_24\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"100\" Height=\"60\" X=\"10\" Y=\"150\" Effect=\"ThreeD\" Text=\"OK\"/><Widget ID=\"FUN_CANCEL\" FontName=\"COM_B_24\" BGColor=\"0000FF\" FGColor=\"000000\" Width=\"100\" Height=\"60\" X=\"120\" Y=\"150\" Effect=\"ThreeD\" Text=\"Cancel\"/></PinPad>";

function ResetParameters()
{
	 retval=null;
	 cmdOpenConn=null;
	 cmdOpenConnObj=null;
}
function ResetFunctionalParameters()
{
	currentScreenId = 12;
	currentEventCode=0;
	tempPoints.length = 0;
	points.length = 0;
	gBrowser.contentDocument.getElementById('lblError').innerHTML = "";
	SetSignatureImage(orgWidth, orgHeight, null);
	canvasObj=gBrowser.contentDocument.getElementById('cCanvas');
	canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
	canvasObj.getContext('2d').beginPath();
    isCancelled=false;
}
 
 function OpenPopup() 
{
	gBrowser.contentDocument.getElementById('lblError').innerHTML = '';
	var divToOpen = 'SignDiv'
	var popupSetting = { width: '500', height: '400',isFixed:true };
	ShowPopup(divToOpen, popupSetting);
}
 function TopazMozillaSignStart(evt)
{
	 OpenPopup();
	 var closeButton=gBrowser.contentDocument.getElementsByTagName('img')[1];
	 prevClick=closeButton.onclick;
	 closeButton.onclick=false;
	 gBrowser.contentDocument.getElementsByTagName('img')[1].src="images/close-1.png";
	 timeoutID = setTimeout(TopazMozillaOpenConnection, 2000);
	 console.log('timeoutID while creating is :'+ timeoutID);
}
function EnableCloseButton()
{
	console.log('called close button');
	gBrowser.contentDocument.getElementsByTagName('img')[1].src="images/close.png";
	gBrowser.contentDocument.getElementsByTagName('img')[1].onclick=prevClick;
}
function TopazMozillaOpenConnection()
{

//	console.log("appversion=" + navigator.appVersion);
    if ( navigator.appVersion.indexOf("Win")!=-1) {
       mylib=ctypes.open(mylibPath_win);
    } else if ( navigator.appVersion.indexOf("X11")!=-1 || navigator.appVersion.indexOf("Linux")!=-1) {
       mylib=ctypes.open(mylibPath_linux)
    }
    //Declare Signature data polling function
    signatureFunc = mylib.declare("SignatureData",ctypes.default_abi,ctypes.char.ptr);
    widgetFunc = mylib.declare("WidgetData",ctypes.default_abi,ctypes.char.ptr);

	ResetParameters();
	ResetFunctionalParameters();
	try
	{
		send = mylib.declare("JsonDeserialize",ctypes.default_abi,ctypes.char.ptr, ctypes.char.ptr);
		// OPen the connection
		cmdOpenConn = {"command": 1 , "inking": false , "inkRegionx": 0 , "inkRegiony": 0, "inkRegionWidth": 0 , "inkRegionHeight":0, "widgetLayout": ''};
		cmdOpenConnObj=JSON.stringify(cmdOpenConn);
		retval =send(cmdOpenConnObj);
		retval=retval.readString();
		if(retval !=null || retval!="")
		{
			var obj = JSON.parse(retval); 
			if(obj.status==true)
			{
				isConnOpen=true;
				ResetParameters();
				initDrawParams();
				//Send confirm xml
				cmdOpenConn = {"command": 3 , "inking": false , "inkRegionx": 0 , "inkRegiony": 0, "inkRegionWidth": 0, "inkRegionHeight":0, "widgetLayout": confirmXml};
				cmdOpenConnObj=JSON.stringify(cmdOpenConn);
				commandReturnVal =send(cmdOpenConnObj);
				commandReturnVal=commandReturnVal.readString();
				if ( commandReturnVal != null || commandReturnVal != "" )
				{
					var oobj = JSON.parse(commandReturnVal)
					if(obj.status==true)
					{
						//console.log('Starting timer...');
						gTimer = setInterval(function(){PollTimer()}, 500);
					}
				}
			}
			else
			{
				ClearALL();
				SetTextOnCanvas("Device not found.", true);
				hideScreen();
			}
			console.log('set timeout');
			console.log('timeoutID while clearing is :'+ timeoutID);
			clearTimeout(timeoutID);
		}
	}
	catch(e)
	{
	   console.log('Error is :'+ e);
	}
}
function GetWidgetEvents(widgetID, widgetType, eventCode)
{
	//console.log("Widget ID: " + widgetID + " WidgetType: " + widgetType + " EventCode: " + eventCode);
		
	if ( eventCode == 3 ||eventCode == 5)
	{
		if (widgetID == 2) 
		{
			//Accept
			isSigned = true;
			execPinPad = false;
			//CloseConnection();
			scaleAndDrawSignature();
		}
		else if (widgetID == 3) 
		{
			//Clear
			RefreshScreen();
		}
		else if (widgetID == 4) 
		{
			//Cancel
			ClearALL();
			SetTextOnCanvas("User cancelled signing.", true);
			//gBrowser.contentDocument.getElementById('lblError').innerHTML = "User cancelled signing.";
			hideScreen();
		}
		else if (widgetID == 12 || widgetID == 13 || widgetID == 14)
		{
			currentScreenId = widgetID;
			currentEventCode=eventCode;
	//console.log("set currentScreenId: " + currentScreenId + "currentEventCode: " + eventCode);
		}
		else if (widgetID == 15) 
		{
	//console.log("Got widgetID 15, currentScreenId: " + currentScreenId + "currentEventCode: " + eventCode);
			if(currentScreenId == 12) 
			{
				//Create Screen
				CreateScreen();
			}
			else if((currentScreenId == 13) && (currentEventCode == 3))
			{
				/*
					//Pinpad
					var now = new Date(); 
					var datetime=now.getHours()+':'+now.getMinutes()+':'+now.getSeconds(); 
			    */
				try {
					console.log("creating pinpad.......");
					CreatePinPad();
				} catch (e) {
					console.log("got exception from pinpad");
					SetTextOnCanvas("PinPad Timeout.", true);
					hideScreen();
				}
    		} 
			else if(currentScreenId == 14) 
			{
			    SetTextOnCanvas("User opt-out.", true);
				gBrowser.contentDocument.getElementsByTagName('img')[0].src ="images/signImage_400.png";
			    //gBrowser.contentDocument.getElementById('lblError').innerHTML = "User opt out.";
				hideScreen();
				CloseConnection();
			}
		} 
		
	}
}
function GetSignaturePoints(xAxis, yAxis, pressure,time)
{
	try
	{
		points.push({ x: xAxis, y: yAxis, pressure: pressure });
		//if(gBrowser.contentDocument.getElementById('option_real').checked) 
		//{
		
			if (points.length > 0) {
				var lCurX = 0.0;
				var lCurY = 0.0;
				//calculate the X and Y with respect to the currently set drawing object
				lCurX = xScale * xAxis;
				lCurY = yScale * yAxis;
				//check if pen down or pen up
				if (pressure != 0) {
					//check if it is the first touch in the stroke
					if (g_fFirstTouch) {
						//draw the line
						ctx.moveTo(lCurX, lCurY)
						g_fFirstTouch = false;
					}
					else {
						ctx.lineTo(lCurX, lCurY)
						ctx.stroke();
					}
				}
				else {
					//set the first touch 
					g_fFirstTouch = true; ;
				}
			} else {
				console.log('points <= 0');
			}
		//}			
	}
	catch(e)
	{
		console.log('Error is :'+ e);
	}
}
// Adding DOM event 
document.addEventListener("TopazMozillaSignStartEvent", TopazMozillaSignStart, false, true);
document.addEventListener("TopazMozillaSignCloseEvent", TopazMozillaSignClose, false, true);
//window.addEventListener("beforeunload", function(e) {
//   CloseConnection();
//   e.returnValue = "close connection before unload";
//});
function TopazMozillaSignClose(evt)
{
	if(isConnOpen)
	{
		console.log('Connection is opened so closing..');
		points.length = 0;
		tempPoints.length = 0;
		canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
		canvasObj.getContext('2d').beginPath();
		gBrowser.contentDocument.getElementsByTagName('img')[0].src ="images/signImage_400.png";
		CloseConnection();
	
	}
}
window.addEventListener('unload', function(event) {
		//console.log('Window unloading..');
        if(isConnOpen)
			CloseConnection();
		else
			console.log('Returning no active connection is open');
      });

function PollTimer()
{
	// Signature capture screen is created start polling for the points.
	var data = "";
	data = widgetFunc();
	data=data.readString();
	//console.log(data);
	if ( data != "\"\"" ) {
		//console.log('Widget Event Received'+data);
		//parse and handle widget event
        ParsePollData(1, data);
	} else {
		//console.log('into signature poll loop');
		
		do {
			clearInterval(gTimer);
			bFound = false;
			data="";
			data =signatureFunc();
			data=data.readString();
			if ( data != "\"\"" ) {
				//console.log('Signature event received='+ data);
				ParsePollData(2, data);
				bFound = true;
			}
		} while ( bFound );
		gTimer = setInterval(function(){PollTimer()}, 500);
	}
	EnableCloseButton();
}
function ParsePollData( type, SigData )
{
	//console.log("ParseSigData with " + SigData);
	var res = SigData.split(",");
    if ( type == 1 ) {
	    var wid = parseInt(res[0]);
        var wtype = parseInt(res[1]);
        var wcode = parseInt(res[2]);
      
	    //console.log("wid=" + wid + ",wtype=" + wtype +",code=" + wcode);

	    GetWidgetEvents(wid, wtype, wcode);
    } else if ( type == 2 ) {
	    var x = parseInt(res[0]);
        var y = parseInt(res[1]);
        var p = parseInt(res[2]);
        var t = parseInt(res[3]);
	    //console.log("x=" + x + ",y=" + y +",p=" + p + ",t=" + t);

	    GetSignaturePoints(x, y, p, t);
    }
}
function CloseConnection()
{
	try
	{
		ResetParameters();
		gBrowser.contentDocument.getElementById('lblError').innerText = "";
		cmdOpenConn = {"command": 2 , "inking": false , "inkRegionx": 0 , "inkRegiony": 0, "inkRegionWidth": 0 , "inkRegionHeight": 0, "widgetLayout": '' };

		cmdOpenConnObj=JSON.stringify(cmdOpenConn);
		retval = send(cmdOpenConnObj);
		retval=retval.readString();
		currentScreenId = 12;
		currentEventCode=0;
		//console.log(bFound);
		// Do not stop the timer until all the signature points are polled.
    	clearInterval(gTimer);
		isConnOpen=false;
	}
	catch(e)
	{
		console.log('Error is :'+ e);
	}
}
function CreateScreen()
{
	ResetParameters();
	try
	{	
		cmdOpenConn = {"command": 3 , "inking": true , "inkRegionx": 0 , "inkRegiony": 0, "inkRegionWidth": 480 , "inkRegionHeight":200, "widgetLayout": createScreenXml};
		cmdOpenConnObj=JSON.stringify(cmdOpenConn);
		retval =send(cmdOpenConnObj);
		retval=retval.readString();
		if(retval !=null || retval!="")
		{
            console.log('Screen Creation OK');
		} else
		{
			console.log('Screen Creation failed');
		}
	}
	catch(e)
	{
		console.log('Error is :'+ e);
	}
}
function RefreshScreen()
{
	try
	{
		ResetParameters();
		cmdOpenConn = { "command": 5, "inking": false, "inkRegionx": 0, "inkRegiony": 0, "inkRegionWidth": 0, "inkRegionHeight": 0, "widgetLayout": '' };
		cmdOpenConnObj=JSON.stringify(cmdOpenConn);
		retval = send(cmdOpenConnObj);
		retval=retval.readString();
		points.length = 0;
        tempPoints.length = 0;
        canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
        canvasObj.getContext('2d').beginPath();
	}
	catch(e)
	{
		console.log('Error is :'+ e);
	}
}
function CreatePinPad()
{
	ResetParameters();
	try
	{
		console.log('pinpad start........')
		canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
        canvasObj.getContext('2d').beginPath();
	
		gBrowser.contentDocument.getElementsByTagName('img')[0].src ="images/signImage_400.png";
		
		
		cmdOpenConn = {"command": 4 , "inking": false , "inkRegionx": 0 , "inkRegiony": 0, "inkRegionWidth": 0 , "inkRegionHeight":0, "widgetLayout": pinPadxml};
		cmdOpenConnObj=JSON.stringify(cmdOpenConn);
		retval =send(cmdOpenConnObj);
		retval=retval.readString();
		var obj = JSON.parse(retval); 
		if(obj.status==true)
		{
			if (typeof obj.message == "undefined" || obj.message == "")
			{
                gBrowser.contentDocument.getElementById('lblError').innerHTML = "";
                var err = "Invalid pin specified. Pin should not be null or empty."
                SetTextOnCanvas(err, false);
				hideScreen();
                CloseConnection();
                gBrowser.contentDocument.getElementById('lblError').innerHTML = err;
                return;
            }
			resMsg = "The entered PIN is : " + obj.message;                 
            SetTextOnCanvas(resMsg, false);
			hideScreen();
		}
		else
		{
			resMsg = obj.message;
            SetTextOnCanvas(resMsg, true);
			hideScreen();
			
		}
		CloseConnection();
		//gBrowser.contentDocument.getElementById('lblError').innerHTML = resMsg;
	}
	catch(e)
	{
		console.log('Error is :'+ e);
	}
}
function initDrawParams() {
    g_fFirstTouch = true;
	gBrowser.contentDocument.getElementById('lblError').innerText = "";
    var image = gBrowser.contentDocument.getElementById("signImage");
    canvasObj = gBrowser.contentDocument.getElementById("cCanvas");
    ctx = canvasObj.getContext('2d');
    ctx.lineWidth = 2;
    points.length = 0;
    ctx.strokeStyle = "blue";
    ctx.lineJoin = ctx.lineCap = 'round';
    var deviceWidthinPX = 1024;
    var deviceHeightinPx = 1024;
    xScale = parseInt(canvasObj.width) / deviceWidthinPX;
    yScale = parseInt(canvasObj.height) / deviceHeightinPx;
    epadScale = xScale;
    if (xScale > yScale) epadScale = yScale;
    ctx.beginPath();
}
// Redrawing the signature after scaling.(scaleAndDrawSignature Method)
function scaleAndDrawSignature() {    
    canvasObj = gBrowser.contentDocument.getElementById("cCanvas");
    ctx = canvasObj.getContext('2d');
    //ePad Vision physical sizes
    var dev_physicalX = 3.742;
    var dev_physicalY = 2.12;
    var dpi = 96; // Need to replace this with value read from JS APIS::: Screen Resolution
    //compute the width and height of the component in inches.
    var xLengthInInches = 0.0, yLengthInInches = 0.0;
    var xLengthPx = 0, yLengthPx = 0;
    xLengthPx = parseInt(canvasObj.width);
    yLengthPx = parseInt(canvasObj.height);
    xLengthInInches = xLengthPx / 96; // this dpi
    yLengthInInches = yLengthPx / 96;    
    // Compute minimum x, y of the device reported points.
    minX = points[0].x;
    minY = points[0].y;
    
    if (maxX == 0) {
        maxX = points[0].x;
    }
    if (maxY == 0) {
        maxY = points[0].y;
    }
	
    for (var i = 1; i < points.length; i++) {
        if (maxX < points[i].x) {
            maxX = points[i].x;
        }
        if (minX > (points[i].x) && (points[i].x) != 0) {
            minX = (points[i].x);
        }
    }
    for (var i = 0; i < points.length; i++) {
        if (maxY <= points[i].y) {
            maxY = points[i].y;
        }
        if (minY > points[i].y && points[i].y != 0) {
            minY = points[i].y;
        }
    }    
    // Translate the points to origin
    for (var i = 0; i < points.length; i++) {
        var tempX = points[i].x - minX;
        var tempY = points[i].y - minY;        
        tempPoints.push({ x: (tempX), y: (tempY), pressure: (points[i].pressure) });
    }
    // compute the width and height of the signature
    sizeX = maxX - minX + 1;
    sizeY = maxY - minY + 1;    
    var DeviceX1 = 0.0, DeviceY1 = 0.0;
    DeviceX1 = sizeX * dev_physicalX / maxX;
    DeviceY1 = sizeY * dev_physicalY / maxY;
    var xScale = 0.0, yScale = 0.0;
    xScale = xLengthInInches / DeviceX1;
    yScale = yLengthInInches / DeviceY1;
    scale = xScale;
    if (xScale > yScale) {
        scale = yScale;
    }
    if (scale > 1.0) {
        if (maxUpScaleFactor > scale) {
            scale = scale;
        } else {
            scale = maxUpScaleFactor;
        }
    }
    scale = 0.95 * scale; //this is to avoid cutting of edges when thickness is set to a higher value    
    var xOffset = 0.0, yOffset = 0.0;
    xOffset = ((xLengthInInches - DeviceX1 * scale) / 2.0) * dpi;
    yOffset = ((yLengthInInches - DeviceY1 * scale) / 2.0) * dpi;    
    var g_fFirstTouch = true;
    canvasObj = gBrowser.contentDocument.getElementById("cCanvas");
    ctx = canvasObj.getContext('2d');
    ctx.lineWidth = 4;
    points.length = 0;
    ctx.strokeStyle = "blue";
    ctx.lineJoin = ctx.lineCap = 'round';
    canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
    ctx.beginPath();
    for (var i = 0; i < tempPoints.length; i++) {        
        var xone = (tempPoints[i].x * DeviceX1 * scale / sizeX) * dpi;
        var yone = (tempPoints[i].y * DeviceY1 * scale / sizeY) * dpi;
        xone = xone + xOffset;
        yone = yone + yOffset;        
        if (tempPoints[i].pressure != 0) {
            //check if it is the first touch in the stroke
            if (g_fFirstTouch) {
                //draw the line
                ctx.moveTo(xone, yone)
                g_fFirstTouch = false;
            }
            else {
                ctx.lineTo(xone, yone)
                ctx.stroke();
            }
        }
        else {
            //set the first touch 
            g_fFirstTouch = true; ;
        }
    }
	var imgData;
	imgData = canvasObj.toDataURL();
	if (imgData != "" && imgData != null) {
		SetSignatureImage((canvasObj.width), (canvasObj.height), imgData);
        execPinPad = false;
	}
	else
	{
		SetSignatureImage(orgWidth, orgHeight, null);
	}
	points.length = 0;
	tempPoints.length=0;
    currentScreenId = 12;
	CloseConnection();
}
// Set the text on canvas (SetTextOnCanvas Method)
function SetTextOnCanvas(msg, allow) {
    canvasObj = gBrowser.contentDocument.getElementById('cCanvas');
    ctx = canvasObj.getContext("2d");
    ctx.font = '20pt Calibri';
    ctx.fillStyle = 'blue';
    if (allow) {
        ctx.fillText(msg, 10, 90);
    }
    else {
        var maxWidth = 400;
        var x = (canvasObj.width - maxWidth) / 2;
        var y = 50;
        var lineHeight = 25;
        var minLength = 10; 
        wrapText(ctx, msg, x, y, maxWidth, lineHeight);
    }    
gBrowser.contentDocument.getElementById('lblError').innerHTML=msg;	
gBrowser.contentDocument.getElementById('lblError').style.color = "blue";
gBrowser.contentDocument.getElementById('lblError').style.font = "Calibri";
gBrowser.contentDocument.getElementById('lblError').style.fontSize  = "20pt";
isCancelled=true;
}

// Wrap the text on Canvas (wrapText method)
function wrapText(context, text, x, y, maxWidth, lineHeight) {
    var words = text.split(' ');                         
    var line = '';
    for (var n = 0; n < words.length; n++) {
        var testLine = line + words[n] + ' '+ ' ' ;
        var metrics = context.measureText(testLine);
        var testWidth = metrics.width;
        if (testWidth > maxWidth && n > 0) {
            context.fillText(line, x, y);
            line = words[n] + ' ';
            y += lineHeight;
        }
        else {
            line = testLine;
        }
    }    
    context.fillText(line, x, y);
}
// Set the image data to the image tag (SetSignatureImage method)
function SetSignatureImage(iWidth, iHeight, iData) {
    if (iData != null && iData != "") {
        gBrowser.contentDocument.getElementById('signImage').src = iData;
        gBrowser.contentDocument.getElementById('signImage').width = iWidth;
        gBrowser.contentDocument.getElementById('signImage').height = iHeight;
		gBrowser.contentDocument.getElementsByTagName('img')[0].src =iData;
		hideScreen();
    }

    execPinPad = false;
}
function hideScreen()
{
	var canvasObj=gBrowser.contentDocument.getElementById('cCanvas');
	canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
	canvasObj.getContext('2d').beginPath();
	
	var table = gBrowser.contentDocument.getElementById('table' + 'SignDiv');
	var element = table.parentElement;
	var divElt = gBrowser.contentDocument.getElementById('SignDiv');
	divElt.style.display = 'none';
	var tempElt = gBrowser.contentDocument.getElementById('tempElt' + 'SignDiv');
	tempElt.parentElement.insertBefore(divElt, tempElt);
	table.parentElement.removeChild(table);
	table.setAttribute('style', 'display: none');
	tempElt.parentElement.removeChild(tempElt);
}
function ShowPopup(divId, popupSetting)
{
	var divElt = gBrowser.contentDocument.getElementById(divId);
	divElt.style.display = 'block';
	var element = divElt.parentElement;
	popupSetting = popupSetting || {};

	if (!popupSetting.width) { popupSetting.width = divElt.offsetWidth };
	if (!popupSetting.height) { popupSetting.height = divElt.offsetHeight };
	if (!popupSetting.title) { popupSetting.title = 'ePad-vision SDK'};

	var table = gBrowser.contentDocument.createElement('table');
	table.setAttribute('id', 'table' + divId);table.setAttribute('cellspacing', '0');table.setAttribute('cellpadding', '0');

	var tr1 = gBrowser.contentDocument.createElement('tr'); tr1.className = 'PopupHeader';
	var td1 = gBrowser.contentDocument.createElement('td'); td1.setAttribute('style', 'width: 90%; padding: 3px;');
	var span = gBrowser.contentDocument.createElement('span'); span.innerHTML = popupSetting.title;
	span.setAttribute('style', 'font-size: 12px; font-weight: normal;');
	td1.appendChild(span); tr1.appendChild(td1); table.appendChild(tr1);

	var tr2 = gBrowser.contentDocument.createElement('tr');
	var tdDynamic = gBrowser.contentDocument.createElement('td');
	tdDynamic.setAttribute('align', 'center');
	tdDynamic.setAttribute('style', 'padding-top: 10px; vertical-align:top;'); 

	var tempElt = gBrowser.contentDocument.createElement('div');
	tempElt.setAttribute('id', 'tempElt' + divElt.id);
	divElt.parentElement.insertBefore(tempElt, divElt);

	tdDynamic.appendChild(divElt);
	tr2.appendChild(tdDynamic);
	table.appendChild(tr2);
	
	var cssText = 'display: block; border:1px solid black;  z-index:92000; background-color:white; top:50%; left:50%;';
	cssText += 'width: ' + popupSetting.width + 'px; height: ' + popupSetting.height + 'px; margin-left: -' + Math.round(popupSetting.width / 2) + 'px; margin-top: -' + Math.round(popupSetting.height / 2) + 'px;';

	if (popupSetting.isFixed === true) { cssText += 'position: fixed;';}
	else { cssText += 'position: absolute;'; }

	table.setAttribute('style', cssText);
	element.appendChild(table);
	
	var shadeElt = gBrowser.contentDocument.createElement('div');
	shadeElt.id = "ShadedBG";shadeElt.className = "ShadedBG";
	tempElt.appendChild(shadeElt);
		
}

// Resets the controls (ClearALL Method)
function ClearALL() {
 var image = gBrowser.contentDocument.getElementById('signImage');
    if (canvasObj != null) 
	{
        canvasObj.getContext('2d').clearRect(0, 0, canvasObj.width, canvasObj.height);
	}    
    gBrowser.contentDocument.getElementById('lblError').innerHTML = "";
    execPinPad = false;
    points.length = 0;
    tempPoints.length = 0;
    sizeX = 0;
    sizeY = 0;
    scale = 0.0;
    minX = 99999;
    minY = 99999;
    maxX = 0;
    maxY = 0;    
	CloseConnection();
    image.width = 350;
    image.height = 200;
    image.src = "images/signImage_400.png";
    isSigned = false;    
}


