var siteURL;
var sigImage;
var tabID;
var lblError;
var newWidthWidth = 500;
var newWindowHeight = 400;
var newWindowLeft = ((screen.width/2)-(newWidthWidth/2));
var newWindowTop = ((screen.height/2)-(newWindowHeight/2));
console.log("screen Width and height " + screen.width + " : " + screen.height);
// Handle requests for passwords
chrome.runtime.onMessage.addListener(function(request) {
    console.log(request);
    siteURL = request.siteUrl;
    sigImage = request.signImage;
    lblError = request.errorMessage;
    chrome.tabs.query({ url: request.siteUrl, active: true }, function(arrayOfTabs) {

        // since only one tab should be active and in the current window at once
        // the return variable should only have one entry
        tabID = arrayOfTabs[0].id;
        console.log("current Tab ID " + tabID);
    });
    if (request.type === 'request_signature') {
	    chrome.tabs.create({
            url: chrome.extension.getURL('sigcapture.html'),
            active: false
        }, function(tab) {
        // images/signImage_400.PNG";After the tab has been created, open a window to inject the tab
            chrome.windows.create({
                tabId: tab.id,
                type: 'popup',
                width: newWidthWidth,
                height: newWindowHeight,
                left: newWindowLeft,
                top: newWindowTop,
                focused: true
                // incognito, top, left, ...
            });
        });
    }
});

function setImage(imageData, errorMessage) {
    // Do something, eg..:
    console.log("imageData");
    console.log(imageData);
    console.log(siteURL);
    console.log(tabID);
    console.log("errorMessage", errorMessage);

    if (errorMessage != null && errorMessage != "") {
    console.log("errorMessage != null && errorMessage");
        console.log(imageData);
    chrome.tabs.executeScript(tabID, {
            code: 'document.getElementById(\"' + lblError + '\").innerText="' + errorMessage + '"'
        });
        if (imageData != null) {
            chrome.tabs.executeScript(tabID, {
                code: 'document.getElementById(\"' + sigImage + '\").src="' + imageData + '"'
            });
        }
        else {
            chrome.tabs.executeScript(tabID, {
                code: 'document.getElementById(\"' + sigImage + '\").src="images/signImage_400.png"'
            });
        }
    }
    else {
        chrome.tabs.executeScript(tabID, {
            code: 'document.getElementById(\"' + lblError + '\").innerText=" "'
        });
        if (imageData != null) {
            chrome.tabs.executeScript(tabID, {
                code: 'document.getElementById(\"' + sigImage + '\").src="' + imageData + '"'
            });
        }
    }     
}

function setSignatureImage(imgdata, errMsg) {
    chrome.tabs.executeScript(tabID, {
        code: 'document.getElementById(\"' + sigImage + '\").src="' + imgdata + '"'
    });
    chrome.tabs.executeScript(tabID, {
        code: 'document.getElementById(\"' + lblError + '\").innerText="'+errMsg+'"'
    });
}



